<?php
/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/*
 * Created on 1 août 07 by AEL Sarl for
 * 
 * osCommerce, Open Source E-Commerce Solutions
 * http://www.oscommerce.com
 *
 * Copyright (c) 2003 osCommerce
 *
 * Released under the GNU General Public License
 * 
 */

define('CUSTOM_ERROR_HANDLER', 'oN');
define('WEBMANAGER_CUSTOM_LOG_FILE', 'webmanager.log');

if (defined('CUSTOM_ERROR_HANDLER') && strtolower(CUSTOM_ERROR_HANDLER) == 'on') {

	function webmanager_error_handler ($errno, $errmsg, $file, $lineno, $context) {
		$logger = Logger::getInstance(dirname(__FILE__) . DIRECTORY_SEPARATOR . WEBMANAGER_CUSTOM_LOG_FILE);
		
		switch ($errno) {
			
			case E_NOTICE:
			case E_USER_NOTICE:
				$logger->info($file . " (" . $lineno . ") : " . $errmsg);
				break;
				
			case E_WARNING:
			case E_USER_WARNING:
				$logger->warning($file . " (" . $lineno . ") : " . $errmsg);
				break;
				
			case E_ERROR:
			case E_USER_ERROR:
				$logger->error($file . " (" . $lineno . ") : " . $errmsg);
				$logger->error("Erreur fatale, arrêt.");
				die();
				break;
		}
	}
	
	$old_error_handler = set_error_handler("webmanager_error_handler");
}

/*
 * Format array of
 * key : a constant name, see includes/<language>.php
 * value : an array of values : OpenSI order status name (N, C, E, M) and validation id expected
 *                              in uploadCommandes.java for this name
 */
$OPENSI_ORDERS_STATUS = array(
							"OPENSI_ORDERS_STATUS_NEW" => array("N", 1),
                            "OPENSI_ORDERS_STATUS_PROCESSING" => array("C", 2),
                            "OPENSI_ORDERS_STATUS_SHIPPED" => array("E", 3),
 							"OPENSI_ORDERS_STATUS_FAILURE" => array("M", 0));

define("OPENSI_ORDERS_STATUS_FAILURE", "Non aboutie");
define('OPENSI_ORDERS_STATUS_NEW', 'En Attente');
define('OPENSI_ORDERS_STATUS_PROCESSING', 'Traitement en cours');
define('OPENSI_ORDERS_STATUS_SHIPPED', 'Livrée');

class Logger {
	
	private static $instance;
	
	private function __construct($logfile="webmanager.log") {
		$this->logfile = $logfile;
		try {
			$this->fp = fopen($logfile, 'a');
		} catch (Exception $e) {
			$this->fp = null;
		}
	}
	
	public static function getInstance($logfile) {
		if (!isset(self::$instance)) {
			$cls = __CLASS__;
			self::$instance = new $cls($logfile);
		}
		return self::$instance;
	}
	
	public function __clone() {
		trigger_error('Le clônage n\'est pas autorisé.', E_USER_ERROR);
	}
	
	private function _log($message, $level='INFO') {
		try {
			fwrite($this->fp, "[" . date("m/d/Y h:i:s", mktime()) . "] " . $level . " : " . $message . "\n");	
		} catch (Exception $e) {}
	}
	
	public function info($message) {
		$this->_log($message);
	}
	
	public function warning($message) {
		$this->_log($message, $level='WARNING');
	}
	
	public function error($message) {
		$this->_log($message, $level='ERROR');
	}
}



function preparerSite() {
	
	global $OPENSI_ORDERS_STATUS;
	$logger = Logger::getInstance(dirname(__FILE__) . DIRECTORY_SEPARATOR . "webmanager.log");
	// table for orders_status
	$link = mysql_connect("localhost", "jm", "bzibzou1");
	mysql_select_db("devboutic");
	mysql_query("CREATE TABLE IF NOT EXISTS OPENSI_ORDERS_STATUS (" .
				"Orders_Status_Id INT NOT NULL PRIMARY KEY," .
				" Opensi_Orders_Status_Id INT NOT NULL," .
				" Opensi_Orders_Status_Name CHAR(1))");
	mysql_query("DELETE FROM OPENSI_ORDERS_STATUS");
	mysql_query("INSERT INTO orders_status (orders_status_id, orders_status_name, language_id)" .
	            " VALUES (0, 'Non aboutie', 4)");
	// tester d'abord comme l'original
	$logger->info('Test 1');
	foreach ($OPENSI_ORDERS_STATUS as $key => $array_values) {
		try {
			if (defined($key))
				mysql_query("INSERT INTO OPENSI_ORDERS_STATUS VALUES (" .
						     "(SELECT orders_status_id FROM orders_status" . 
						       " WHERE orders_status_name = '" . constant($key) . "'" .
						       " AND language_id = 4), " .
						       $array_values[1] . ", '" . $array_values[0] . "')");
		} catch (Exception $e) {
			$logger->info($e->getMessage());
		}
	}
	// test
	$test_query = mysql_query("SELECT * FROM OPENSI_ORDERS_STATUS");
	echo '<br />Test 1...........<br />';
	while ($test = mysql_fetch_array($test_query, MYSQL_ASSOC))
		echo $test["Opensi_Orders_Status_Name"] . '<br />';
		
	// test à partir de orders_status
	foreach ($OPENSI_ORDERS_STATUS as $key => $array_values) {
		if (defined($key)) {
			$status_query = mysql_query("SELECT orders_status_id FROM orders_status" . 
					                    " WHERE orders_status_name = '" . constant($key) . "'" .
					                    " AND language_id = 4");
			if(!mysql_num_rows($status_query))
				trigger_error("Clé OPENSI_STATUS définie (" . $key . ") sans correspondance en orders_status.",
				              E_USER_WARNING);
			while ($status = mysql_fetch_array($status_query, MYSQL_ASSOC)) {
				mysql_query("INSERT INTO OPENSI_ORDERS_STATUS VALUES (" .
				            $status["orders_status_id"] . ", " .
                            $array_values[1] . ", '" . 
                            $array_values[0] . "')");
			}
			
		}
	}
	// test de correspondance inverse
	$status_query = mysql_query(
						"SELECT os.orders_status_name" .
	                    " FROM orders_status os LEFT JOIN OPENSI_ORDERS_STATUS oos" .
	                    " ON os.Orders_Status_Id = oos.Orders_Status_Id" .
	                    " WHERE language_id = 4" .
	                    " AND oos.Orders_Status_Id IS NULL");
	while ($status = mysql_fetch_array($status_query, MYSQL_ASSOC)) {
		trigger_error("orders_status name '" . $status['orders_status_name'] . "' défini dans orders_status" .
		              " et sans correspondance dans le tableau des OPENSI_STATUS_*",
		              E_USER_WARNING);
	}                 
	// test
	$test_query = mysql_query("SELECT * FROM OPENSI_ORDERS_STATUS");
	echo '<br />Test 2...........<br />';
	while ($test = mysql_fetch_array($test_query, MYSQL_ASSOC))
		echo $test["Opensi_Orders_Status_Name"] . '<br />';
	        
	mysql_close();
}
echo '<html>';
echo '<body>';
preparerSite();
echo '</body>';
echo '</html>';
?>